
QGIS Application - Bug report #4806

Wrong legends/ramps for rasters

2012-01-13 07:51 AM - Giovanni Manghi

Status: Closed

Priority: High

Assignee:

Category: Rasters

Affected QGIS version:master Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied:No Resolution: fixed

Crashes QGIS or corrupts data:No Copied to github as #: 14658

Description

Steps:

    -  add the attached raster (is a DEM)

    -  calculate the "aspect" map with the terrain analysis tool or with the gdaldem tool

The min/max values of the output are

STATISTICS_MINIMUM=0

STATISTICS_MAXIMUM=359.87353515625

but the legend will show values as

-9.8

398.8

which do not make any sense (see attached screenshot)

Another example is if you reclassify (with the raster calculator) the same DEM to a map with just "0" and "1"

    -  (dem_clipped@1>300)*1 + (dem_clipped@1<=300)*0

the resulting map will show a legend with values as

0.3

1.4

that once again do not make any sense.

History

#1 - 2012-01-15 03:17 AM - Alexander Bruy

Not reproducible here with latest qgis-dev (-37) from OSGeo4W under 32bit Windows XP Pro SP3. Also tested under 32bit Slackware 13.37 with latest

master (4413a7d), GDAL 1.9.0 with same result — not reproducible.

#2 - 2012-01-15 03:25 AM - Giovanni Manghi
Alexander Bruy wrote:

Not reproducible here with latest qgis-dev (-37) from OSGeo4W under 32bit Windows XP Pro SP3. Also tested under 32bit Slackware 13.37 with

latest master (4413a7d), GDAL 1.9.0 with same result — not reproducible.

Hi Alexander, that's weird, I also tested qgis master on both Windows and Linux. Do you mean that you are getting legends with the expected values?

#3 - 2012-01-15 03:30 AM - Alexander Bruy

Giovanni Manghi wrote:

Hi Alexander, that's weird, I also tested qgis master on both Windows and Linux. Do you mean that you are getting legends with the expected

values?

Right, I get correct legend values. In case with reclassified DEM this is 0 and 1. In case with "aspect" analysis results this is 0.14579 and 360. Maybe this is

because you use 64bit system?

#4 - 2012-01-15 03:52 AM - Giovanni Manghi

Alexander Bruy wrote:

Giovanni Manghi wrote:

Hi Alexander, that's weird, I also tested qgis master on both Windows and Linux. Do you mean that you are getting legends with the expected

values?

Right, I get correct legend values. In case with reclassified DEM this is 0 and 1. In case with "aspect" analysis results this is 0.14579 and 360.

Maybe this is because you use 64bit system?

My Linux box is 64 bit but my Windows VM is 32 bit, so should be something else. But what?

#5 - 2012-01-16 03:09 AM - Paolo Cavallini

Confirmed here on Debian unstable 64bit (values from -8 to +399)

#6 - 2012-01-16 05:23 AM - Giovanni Manghi

But I'm sure I got the same also on a 32bit system...

#7 - 2012-01-22 06:11 AM - Giovanni Manghi

- File dem_clipped.tif added

loading the attached raster (dem_lipped.tif), without applying any particular color map, in the legend I see a "-32767-32768" that I also don't uderstand
#8 - 2012-01-22 06:20 AM - Alexander Bruy

Giovanni Manghi wrote:

loading the attached raster (dem_lipped.tif), without applying any particular color map, in the legend I see a "-32767-32768" that I also don't

uderstand

Confirmed but only when contrast enhacement is "Not set" or "Clip to MinMax". In all other cases I get correct values.

After looking into code I found that legend values are gathered from QgsContrastEnhancement object, so if contrast enhacement is "Not set" there are no

values found and defaults used.

#9 - 2012-04-16 06:32 AM - Paolo Cavallini

- Target version changed from Version 1.7.4 to Version 1.8.0

#10 - 2012-09-04 11:54 AM - Paolo Cavallini

- Target version changed from Version 1.8.0 to Version 2.0.0

#11 - 2012-10-04 04:42 PM - Giovanni Manghi

- Resolution set to fixed

- Status changed from Open to Closed

This has been fixed in master.

Files

dem_clipped.tif 498 KB 2012-01-13 Giovanni Manghi

26.png 576 KB 2012-01-13 Giovanni Manghi

dem_clipped.tif 498 KB 2012-01-22 Giovanni Manghi
